// $Id: cpn.js,v 1.2 2011/02/22 15:28:14 joelstein Exp $
(function ($) {

  Drupal.behaviors.cpnCodeMirror = {

    attach: function(context, settings) {

      // Append enable/disable links.
      $('.form-item-cpn-css, .form-item-cpn-js').each(function() {
        $('.description', this).append(' <a href="#" class="cpn-toggle">Enable syntax highlighting</a>.');
      });

      // Toggle syntax highlighting.
      $('.cpn-toggle').click(function() {
        var $textarea = $(this).parents('.form-item').find('textarea');
        var $grippie = $textarea.parents('.resizable-textarea').find('.grippie');
        var type = $textarea.attr('id').replace('edit-cpn-', '');

        // Enable
        if (!$(this).hasClass('enabled')) {
          $grippie.hide();
          var editor = CodeMirror.fromTextArea($textarea.attr('id'), {
            path: Drupal.settings.basePath +'sites/all/libraries/codemirror/js/',
            stylesheet: Drupal.settings.basePath +'sites/all/libraries/codemirror/css/'+ type +'colors.css',
            parserfile: type == 'css' ? ['parsecss.js'] : ['tokenizejavascript.js', 'parsejavascript.js'],
            height: $textarea.height() +'px',
            tabMode: 'shift',
            reindentOnLoad: true
          });
          $(this).data('editor', editor);
          $(this).text(Drupal.t('Disable syntax highlighting')).addClass('enabled');
        }

        // Disable
        else {
          $(this).data('editor').toTextArea();
          $grippie.show();
          $(this).text(Drupal.t('Enable syntax highlighting')).removeClass('enabled');
        }
        return false;
      });

    }

  };

})(jQuery);
